unit UAClock;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FlashViewers, fe_flashplayer, StdCtrls;

{ http://www.delphiflash.com/delphi-swf-sdk-download
  http://www.delphiflash.com/demo-adobe-clock-sample
}

type
  TForm4 = class(TForm)
    FlashViewer: TFlashViewerWindow;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
      var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    ptDown: TPoint;
    isDown: boolean;
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

uses
  Math;

procedure TForm4.FormCreate(Sender: TObject);
begin
  FlashViewer.Align := alNone;
  FlashViewer.SetBounds(0, 0, ClientWidth, ClientHeight);
  FlashViewer.Movie := 'flashpascal.swf';
  FlashViewer.OnMouseDown := FormMouseDown;
  FlashViewer.OnMouseMove := FormMouseMove;
  FlashViewer.OnMouseUp := FormMouseUp;
end;

procedure TForm4.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ptDown := Point(X, Y);
  isDown := true;
end;

procedure TForm4.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if isDown and ((X <> ptDown.X) or (Y <> ptDown.Y)) then
  begin
    Left := Left + X - ptDown.X;
    Top := Top + Y - ptDown.Y;
  end
end;

procedure TForm4.FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  isDown := false;
end;

procedure TForm4.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  if Shift = [ssCtrl] then
    FlashViewer.MasterAlpha := Max(50, FlashViewer.MasterAlpha - sign(WheelDelta) * 5)
  else
 if Shift = [] then
  begin
    if ((WheelDelta > 0) and (Width > 40)) or (WheelDelta < 0) then
      SetBounds(Left + sign(WheelDelta) * 5, Top + sign(WheelDelta) * 5,
                Width - sign(WheelDelta) * 10, Height - Sign(WheelDelta) * 10);
    FlashViewer.SetBounds(0, 0, ClientWidth, ClientHeight);
  end
end;

end.
